io.stdout:setvbuf('no')

-- Dev libraries
Inspect = require 'libs.inspect'
require 'imgui'
local imgui_devTools = require 'imgui_devTools'

-- Global space
require 'globals'

-- Local space
local Game_Class = require 'class.game'
local game, canvas

function love.load()
    imgui_devTools.initialize()
    canvas = love.graphics.newCanvas()
    game = Game_Class:new(canvas)
    love.window.setMode(1440, 900)
end

function love.update(dt)
    game:update(dt)
    imgui_devTools.update(dt)
end

function love.draw()
    game:draw()
    imgui.Begin(tostring(game), true)
        imgui.Image(canvas, canvas:getDimensions())
    imgui.End()
    imgui_devTools.draw()
end

-- Inputs
-- Keyboard
function love.textinput(t)
    imgui.TextInput(t)
end

function love.keypressed(key, scancode, isrepeat)
    imgui.KeyPressed(key)
end

function love.keyreleased(key, scancode)
    imgui.KeyReleased(key)
end

-- Mouse
function love.mousemoved(x, y, dx, dy)
    imgui.MouseMoved(x, y)
end

function love.mousepressed(x, y, button)
    imgui.MousePressed(button)
end

function love.mousereleased(x, y, button)
    imgui.MouseReleased(button)
end

function love.wheelmoved(x, y)
    imgui.WheelMoved(y)
end
